BrowseTable = LibStub("AceAddon-3.0"):NewAddon("BrowseTable")
local BrowseTable = BrowseTable
local AceGUI = LibStub("AceGUI-3.0")

local function TextColor(widget, event)
	if event == "OnEnter" then
		widget:SetColor(1, 1, 1)
	else
		widget:SetColor(0.8, 0.8, 0.8)
	end
end

function BrowseTable:PopulateGUI(frame, ref, name, prev)
	if not prev then
		prev = {[1]={name=(name or tostring(ref)), t = ref}}
	end
	local bar = AceGUI:Create("InlineGroup")
	bar:SetLayout("Flow")
	bar:SetFullWidth(true)
	bar:SetHeight(24)
	bar:SetTitle(nil)
	frame:AddChild(bar)
	if #prev <= 5 then
		for c=1, #prev do
			local text = AceGUI:Create("InteractiveLabel")
			text:SetText(prev[c].name)
			text:SetColor(0.8, 0.8, 0.8)
			text:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			text:SetCallback("OnEnter", TextColor)
			text:SetCallback("OnLeave", TextColor)
			text:SetCallback("OnClick", function() frame:ReleaseChildren() local newprev = {} for i=1, c do newprev[i] = prev[i] end BrowseTable:PopulateGUI(frame, prev[c].t, prev[c].name, newprev) end)
			text:SetRelativeWidth(0.2)
			bar:AddChild(text)
		end
	else
		do
			local text = AceGUI:Create("InteractiveLabel")
			text:SetText("...")
			text:SetColor(0.8,0.8,0.8)
			text:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			text:SetCallback("OnEnter", TextColor)
			text:SetCallback("OnEnter", TextColor)
			text:SetCallback("OnClick", function() frame:ReleaseChildren() BrowseTable:PopulateGUI(frame, prev[1].t, prev[1].name) end)
			text:SetRelativeWidth(0.2)
			bar:AddChild(text)
		end
		for c=(#prev-3), #prev do
			local text = AceGUI:Create("InteractiveLabel")
			text:SetText(prev[c].name)
			text:SetColor(0.8, 0.8, 0.8)
			text:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
			text:SetCallback("OnEnter", TextColor)
			text:SetCallback("OnLeave", TextColor)
			text:SetCallback("OnClick", function() frame:ReleaseChildren() local newprev = {} for i=1, c do newprev[i] = prev[i] end BrowseTable:PopulateGUI(frame, prev[c].t, prev[c].name, newprev) end)
			text:SetRelativeWidth(0.2)
			bar:AddChild(text)
			if c ~= #prev then
				local arrow
			end
		end
	end
	local inline = AceGUI:Create("ScrollFrame")
	inline:SetFullWidth(true)
	inline:SetFullHeight(true)
	frame:AddChild(inline)
	for key, value in pairs(ref) do
		local group = AceGUI:Create("SimpleGroup")
		group:SetFullWidth(true)
		group:SetLayout("flow")
		inline:AddChild(group)
		local text = AceGUI:Create("Label")
		text:SetText(key)
		text:SetRelativeWidth(0.5)
		text:SetColor(0.8, 0.8, 0.8)
		text:SetFont("Fonts\\FRIZQT__.TTF", 13, "")
		group:AddChild(text)
		local valuetext = AceGUI:Create("Label")
		valuetext:SetText(tostring(value))
		valuetext:SetRelativeWidth(0.32)
		valuetext:SetColor(0.8, 0.8, 0.8)
		valuetext:SetFont("Fonts\\FRIZQT__.TTF", 13, "")
		local delete = AceGUI:Create("Button")
		delete:SetRelativeWidth(0.07)
		delete:SetText("D")
		delete:SetCallback("OnClick", function() ref[key] = nil; frame:ReleaseChildren(); BrowseTable:PopulateGUI(frame, ref, name, prev) end)
		local addbutton
		if type(value) == "function" then
			addbutton = AceGUI:Create("Button")
			addbutton:SetRelativeWidth(0.07)
			valuetext:SetRelativeWidth(0.25)
			addbutton:SetText("E")
			addbutton:SetCallback("OnClick", function() print("|cffff0000BrowseTable:|r ", value()) end)
		end
		if type(value) == "table" then
			addbutton = AceGUI:Create("Button")
			addbutton:SetRelativeWidth(0.07)
			valuetext:SetRelativeWidth(0.25)
			addbutton:SetText("G")
			addbutton:SetCallback("OnClick", function() frame:ReleaseChildren() local newprev = {} for i=1, #prev do newprev[i] = prev[i] end newprev[#newprev+1] = {name=key, t=value} BrowseTable:PopulateGUI(frame, value, key, newprev) end)
		end
		group:AddChild(valuetext)
		if addbutton then
			group:AddChild(addbutton)
		end
		group:AddChild(delete)
	end
end

function BrowseTable:DirectOpenTable(ref, name)
	if type(ref) ~= "table" then error("Invalid argument #1 to BrowseTable:DirectOpenTable. Expected table, got "..type(ref)..".") end
	self.frame = AceGUI:Create("Frame")
	local frame = self.frame
	frame:SetTitle("Table browser")
	frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
	self:PopulateGUI(frame, ref, name or tostring(ref))
end

local function OpenTable(input)
	if input=="" then print("Usage: /browse <table>") return end
	local t = loadstring("return "..input)
	if type(t) == "function" then
		t = t()
	end
	if not t then print("Table "..input.." not found") return end
	if type(t) ~= "table" then print("Variable "..t.." is not a table, but a "..type(t)..".") return end
	BrowseTable.frame = AceGUI:Create("Frame")
	local frame = BrowseTable.frame
	frame:SetTitle("Table browser")
	frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
	BrowseTable:PopulateGUI(frame, t, input)
end
SlashCmdList["BROWSETABLE"] = OpenTable
SLASH_BROWSETABLE1 = "/browse"
SLASH_BROWSETABLE2 = "/browsetable"
